angular.module("ionic").config(function($provide) {
  $provide.decorator('ionSpinnerDirective', function($delegate,$compile) {
    var directive = $delegate[0];
    directive.template = "<img src='img/ib-apploader.gif' style='position:relative; top:50% ; left:50%;'></img>" 
    directive.compile = function()  {
      return function() {
      }
    }

    return $delegate;
  });
});

bab_app
//tab-detector for one was scroll
.directive('tapDetector', function($ionicGesture,$ionicScrollDelegate){
  return{
    restrict:'EA',
    link:function(scope,element){
      var startX,startY,isDown=false;
      element.bind("mousedown touchstart", function(e){
        e=(e.touches)?e.touches[0]:e;//e.touches[0] is for ios
        startX = e.clientX;
        startY = e.clientY;
        isDown=true;
        // console.log("mousedown",startX,startY);
      });

      element.bind("mousemove touchmove", function(e){
        e=(e.touches)?e.touches[0]:e;//e.touches[0] is for ios
        if(isDown){
          var deltaX = Math.abs(e.clientX - startX);
                var deltaY = Math.abs(e.clientY - startY);

          if(deltaX > deltaY) {
          // console.log("horizontal move");
            $ionicScrollDelegate.$getByHandle('mainScroll').freezeScroll(true);
            }
        }
      });

      element.bind("mouseup touchend", function(e){
        isDown=false;
        $ionicScrollDelegate.$getByHandle('mainScroll').freezeScroll(false);
        // console.log("mouseup touchend");
      });
    }
  }
})
.directive('imageTag',[function(){
  var image={};
  image.restrict= 'EA'
  image.scope = {
    width : "@width",
    source : "=source",
    height : "@height"
  }
  image.template= "<img ng-src='{{source}}' style='width: {{width}}; height:{{height}}'>"
  return image;
}])

.directive('allowVerticalSwipe', function(){
  var allowVerticalSwipe = {};
  allowVerticalSwipe.restrict = 'EA';
  allowVerticalSwipe.link = function(scope, element, attr) {
    scope.handle = attr.delegateHandle;
  }
  allowVerticalSwipe.controller = function($scope, $ionicScrollDelegate, $timeout){

    // code to override horizontal ion scroll touch behavior - begin
    $timeout(function(){
      // return false; // <--- comment this to 'fix' the 'horizontal scroll blocking page scroll'
      var sv = $ionicScrollDelegate.$getByHandle($scope.handle).getScrollView();

      var container = sv.__container;

      var originaltouchStart = sv.touchStart;
      var originalmouseDown = sv.mouseDown;
      var originaltouchMove = sv.touchMove;
      var originalmouseMove = sv.mouseMove;

      container.removeEventListener('touchstart', sv.touchStart);
      container.removeEventListener('mousedown', sv.mouseDown);
      document.removeEventListener('touchmove', sv.touchMove);
      document.removeEventListener('mousemove', sv.mousemove);
      

      sv.touchStart = function(e) {
        e.preventDefault = function(){}
        if(originaltouchStart)
          originaltouchStart.apply(sv, [e]);
      }

      sv.touchMove = function(e) {
        e.preventDefault = function(){}
        if(originaltouchMove)
          originaltouchMove.apply(sv, [e]);
      }
      
      sv.mouseDown = function(e) {
        e.preventDefault = function(){}
        if(originalmouseDown)
          originalmouseDown.apply(sv, [e]);
      }

      sv.mouseMove = function(e) {
        e.preventDefault = function(){}
        if(originalmouseMove!=undefined)
          originalmouseMove.apply(sv, [e]);
      }

      container.addEventListener("touchstart", sv.touchStart, false);
      container.addEventListener("mousedown", sv.mouseDown, false);
      document.addEventListener("touchmove", sv.touchMove, false);
      document.addEventListener("mousemove", sv.mouseMove, false);
    });
    // code to override horizontal ion scroll touch behavior - end

  };
  return allowVerticalSwipe;
})

//directive for disable options in ng-options directive
.directive('optionsDisabled', function($parse) {
  var disableOptions = function(scope, attr, element, data, fnDisableIfTrue) {
    // refresh the disabled options in the select element.
    angular.forEach(element.find("option"), function(value, index){
      var elem = angular.element(value);
      if(elem.val()!=""){
        var locals = {};
        locals[attr] = data[index];
        elem.attr("disabled", fnDisableIfTrue(scope, locals));
      }
    });
  };
  return {
    priority: 0,
    require: 'ngModel',
    link: function(scope, iElement, iAttrs, ctrl) {
      // parse expression and build array of disabled options
      var expElements = iAttrs.optionsDisabled.match(/^\s*(.+)\s+for\s+(.+)\s+in\s+(.+)?\s*/);
      var attrToWatch = expElements[3];
      var fnDisableIfTrue = $parse(expElements[1]);
      scope.$watch(attrToWatch, function(newValue, oldValue) {
        if(newValue)
          disableOptions(scope, expElements[2], iElement, newValue, fnDisableIfTrue);
      }, true);
      // handle model updates properly
      scope.$watch(iAttrs.ngModel, function(newValue, oldValue) {
        var disOptions = $parse(attrToWatch)(scope);
        if(newValue)
          disableOptions(scope, expElements[2], iElement, disOptions, fnDisableIfTrue);
      });
    }
  };
})

.directive('remoteCss',['babConfig',function(bc){
  var remoteCss = {};
  remoteCss.restrict = "E";
  remoteCss.link = function(scope,element,attrs){
    element.replaceWith("<link rel='stylesheet' type='text/css' href="+bc.host+"/assets/css/app-remote.css?v="+bc.js_version()+">")
  }
  return remoteCss;

}])