bab_app

.factory('babRA', ['Restangular', 'babConfig', '$location', 'localStorageService', '$state', '$ionicPopup', '$window', 'identityService',
    function (Restangular, babConfig, $location, localStorageService, $state, $ionicPopup, $window, identityService) {
      return Restangular.withConfig(function(RestangularConfigurer) {
        RestangularConfigurer.setBaseUrl(babConfig.rest_host + "/api/v1");

        RestangularConfigurer.setErrorInterceptor(function(response, deferred, responseHandler) {   
          

          if (response.status === 401) {
            console.log("Error Interceptor");
            var redirectUrl = $location.url();
            console.log(JSON.stringify(redirectUrl));
            identityService.loginByAuthKey().then(function(status) {
              console.log(status);
              if(status === "success") {
                $location.url(redirectUrl);
              } else {
                $state.go('authenticate',{'redirectUrl': redirectUrl})
              } 
            });            
            return false;
          }

          if (response.status === 426 && !window.IBresponseErrorPopup) {
            console.log("Needs an update");
            window.IBresponseErrorPopup = $ionicPopup.show({
              title: "Upgrade",
              template: " <div><b> Update Required</b></div>To get the latest features, please update Infibeam now",
              cssClass : "update-pop-up",
              buttons: [
              {
                text: 'UPDATE',
                type: 'button-full button-large button-energized',
                onTap : function(e){
                  return true;
                }
              },
              {
                text: 'Exit',
                type: 'button-light button-small',
                onTap : function(e){
                  return false;
                }
              }
              ]
            });
            window.IBresponseErrorPopup.then(function(result) {
              if(result) {
                cordova.plugins.market.open('com.infibeam.infibeamapp');
                window.IBresponseErrorPopup.close();
                ionic.Platform.exitApp();
              } else {
                window.IBresponseErrorPopup.close();
                ionic.Platform.exitApp();
              }
            });
          }  

          
          if(navigator.connection && navigator.connection.type == "none" && !window.IBresponseErrorPopup) {
            window.IBresponseErrorPopup = $ionicPopup.show({
              title: "Internet Disconnected",
              template: "The internet is disconnected on your device. Do you wish to retry?",
              cssClass : "no-network-popup",
              buttons: [
              {
                text: 'Close',
                onTap : function(e){
                  return false;
                }
              },
              {
                text: 'Retry',
                type: 'button-positive',
                onTap : function(e){
                  return true;
                }
              }
              ]
            });
            window.IBresponseErrorPopup.then(function(result) {
              if(result) {
                window.IBresponseErrorPopup.close();
                $window.location.reload(true);
              } else {
                window.IBresponseErrorPopup.close();
                ionic.Platform.exitApp();
              }
            });
            setInterval(function(){
              if(navigator.onLine){
                window.IBresponseErrorPopup.close();
                $window.location.reload(true);
              }
            }, 3000);
            return false;
          }

          var norefresh=false;
          if(response.config.params!=undefined && response.config.params['prop.page']!=undefined && response.config.params['prop.page']>1){
            norefresh=true;
          }

          
          if(!window.IBresponseErrorPopup && (response.status === 0 || response.status === 408) && ($location.path().indexOf('retry') < 0) && navigator.onLine && !norefresh)
          {
            window.IBresponseErrorPopup = $ionicPopup.show({
              title: "Timeout",
              template: "Taking too much time to load. Do you wish to retry?",
              buttons: [
              {
                text: 'Close',
                onTap : function(e){
                  return false;
                }
              },
              {
                text: 'Retry',
                type: 'button-positive',
                onTap : function(e){
                  return true;
                }
              }
              ]
            });
            window.IBresponseErrorPopup.then(function(result) {
              if(result) {
                window.IBresponseErrorPopup.close();
                $window.location.reload(true);
              } else {
                window.IBresponseErrorPopup.close();
              }
            });
            return false;
          }
          
        });

        RestangularConfigurer.setDefaultHeaders({
          'Content-Type': 'application/json',
          'X-Requested-With': 'XMLHttpRequest',
          'From-App': 'True',
          'AppRegId': localStorageService.get('appRegId'),
          'versionCode' : window.Infibeam.versionCode
        });
      });
    }
])


.factory('myAccountRA', ['babRA', function (babRA){
  return babRA
}])

.factory('loginRA', ['Restangular', 'babConfig', 'localStorageService', function(Restangular, babConfig, localStorageService) {
  return Restangular.withConfig(function(RestangularConfigurer) {
        RestangularConfigurer.setBaseUrl(babConfig.rest_host + "/api/v1");
        RestangularConfigurer.setDefaultHeaders({
          'Content-Type': 'application/json',
          'X-Requested-With': 'XMLHttpRequest',
          'From-App': 'True',
          'AppRegId': localStorageService.get('appRegId'),
          'versionCode' : window.Infibeam.versionCode
        });        
      });
}])

.service('GlobalHelper', [function () {
  // pass a list in format {"method1 name": "method1 type", "method2 name": "method2 type"}
  this.addMethods = function (ra_obj, list, srvc) {
    _.each(list,function (v,k){
      ra_obj.addRestangularMethod(k,v,k);
      srvc[k] = _.bind(ra_obj[k],ra_obj);
    })
  }
}])

.factory('imageResSrcFix', [function(){
  return function(src, width, height, breakpoint, highQuality) {
    if(!src)
      return "";
    if(!width) width = '';
    if(!height) height = '';
    if(!breakpoint) breakpoint = 60;
    width = width - (width%breakpoint);
    highQuality = !highQuality ? "" : "xhigh";
    if(/999x/.test(src)) {
      return src.replace(/(.*?)\.(.{3,4}?)(\..*)?(\.999x.*)*(\.999x.*)\.(.{3,4}?)$/,"$1.$2$3$4.999x"+width+"x"+height+highQuality+".$6");
    } else {
      return src.replace(/(.*?)\.(.{3,4}?)(\..*)?$/,"$1.$2$3.999x"+width+"x"+height+highQuality+".$2");
    }
  }
}])

.factory('retinaImageGet', ['imageResSrcFix', function(imageResSrcFix){
  return function(src, width, height, breakpoint, factor) {
    if(!src) return "";
    factor = !factor ? 1.5 : factor;
    var lowDPI = imageResSrcFix(src, width, height, breakpoint, true);
    //multiply width and height for retina
    width = width ? parseInt(width*factor) : '';
    height = height ? parseInt(height*factor) : '';
    var Retina = imageResSrcFix(src, width, height, breakpoint, false);
    return lowDPI + " 1x, " + Retina + " 2x";
  }
}])

.service('IBappHistoryService', [function(){
  var homePage = '/apptestpage';
  var HS = {};
  HS.stack = [];
  HS.cursor = 0;
  HS.push = function(location) {
    if(!HS.stack.length){
      HS.stack[0] = location;
      return HS;
    }
    if(location == '/webintendrouting' || location == '/checkout/show' || location == '/customers/login'){
      return HS;
    }
    if(location == '/' || location == homePage)
    {
      HS.stack = [];
      HS.cursor = 0;
      return HS;
    }
    if(HS.stack[HS.cursor] != location){
      HS.cursor++;
      HS.stack[HS.cursor] = location;
      return HS;
    }
    return HS;
  }
  HS.pop = function(){
    if(HS.cursor){
      HS.cursor--;
    }
    return HS;
  }
  HS.hasBack = function(){
    return (HS.cursor ? true : false);
  }
  HS.previous = function(){
    if(!HS.stack.length || !HS.cursor)
      return '/';
    return HS.stack[HS.cursor-1];
  }
  HS.current = function(){
    if(!HS.stack.length || !HS.cursor)
      return '/';
    return HS.stack[HS.cursor]; 
  }
  return HS;
}])

.service('GA',['$cordovaGoogleAnalytics', function($cordovaGoogleAnalytics){
  return function(callback){
    function _waitForAnalytics(){
      if(typeof analytics !== 'undefined'){
        console.log('GA ready');
        $cordovaGoogleAnalytics.debugMode();
        $cordovaGoogleAnalytics.startTrackerWithId('UA-66245664-1');
        callback();
      }
      else{
        setTimeout(function(){
          _waitForAnalytics();
        },100);
      }
    };
    _waitForAnalytics();
  }
}])

.service('webUrlConvertService', ['babRA', function(babRA){
  var webUrlRA = babRA.withConfig(function(RestangularConfigurer) {
    RestangularConfigurer.addElementTransformer('url-conversions', false, function (appUrl) {
      return appUrl;
    });
  });

  this.convert = function (webUrl){
    return webUrlRA.all("url-conversions").one("random").customGET("convert", {"original" : webUrl});
  }
}])

.service('notificationService', ['$cordovaToast', function($cordovaToast) {

  this.clear = function(){
  };
  
  this.forceClear = function(){
  };
  
  this.add = function(message, type, count) {
    if($cordovaToast)
      $cordovaToast.showLongTop(message);
  };
  
  this.close = function(index) {
  };

}])

angular.module('ngIOS9UIWebViewPatch', ['ng']).config(function($provide) {
  $provide.decorator('$browser', ['$delegate', '$window', function($delegate, $window) {

    if (isIOS9UIWebView($window.navigator.userAgent)) {
      return applyIOS9Shim($delegate);
    }

    return $delegate;

    function isIOS9UIWebView(userAgent) {
      return /(iPhone|iPad|iPod).* OS 9_\d/.test(userAgent) && !/Version\/9\./.test(userAgent);
    }

    function applyIOS9Shim(browser) {
      var pendingLocationUrl = null;
      var originalUrlFn= browser.url;

      browser.url = function() {
        if (arguments.length) {
          pendingLocationUrl = arguments[0];
          return originalUrlFn.apply(browser, arguments);
        }

        return pendingLocationUrl || originalUrlFn.apply(browser, arguments);
      };

      window.addEventListener('popstate', clearPendingLocationUrl, false);
      window.addEventListener('hashchange', clearPendingLocationUrl, false);

      function clearPendingLocationUrl() {
        pendingLocationUrl = null;
      }

      return browser;
    }
  }]);
});