angular.module('pnpAppMain', ['pnpCore', 'pnpHeader', 'pnpContent', 'pnpProduct', 'pnpCart', 'pnpWishlist', 'pnpSearch', 'pnpAutocomplete', 'pnpCheckoutComplete', 'pnpMagicbox', 'pnpAuthentication', 'pnpPushNotificationRegister','pnpRecharge', 'timer', 'ionic'])
.config(function (RestangularProvider,$stateProvider, $urlRouterProvider){
	$stateProvider
});


bab_app = angular.module('babApp', ['pnpAppMain', 'ionic', 'restangular','ngCordova', 'angular-carousel',
 'angular-loading-bar', 'afkl.lazyImage', 'LocalStorageModule','oc.lazyLoad','ngIOS9UIWebViewPatch']);

bab_app
.config(function (RestangularProvider,$stateProvider, $urlRouterProvider, cfpLoadingBarProvider, localStorageServiceProvider, endPointsProvider, $ionicConfigProvider){
  cfpLoadingBarProvider.includeSpinner = false;
  //cfpLoadingBarProvider.spinnerTemplate = "<img src='img/ib-apploader.gif' style='position:relative; top:50% ; left:50%;'></img>";

  $ionicConfigProvider.views.swipeBackEnabled(false);

  $stateProvider

  // setup an abstract state for the tabs directive

  .state('home', {
    cache: false,
    url: "/",
    params: {
      page_url : endPointsProvider.getConfig().home_page,
    },
    templateUrl: "lib/pnp-content/templates/page.html",
    controller: 'pageViewCntrl'
  })
  
  .state('pnp', {
    url: '/pnp/:controller/:action',
    templateUrl: function($stateParams) {
      return endPointsProvider.getConfig().remote + '/angular/templates/app/'+ $stateParams.controller+'/'+$stateParams.action+'.html'
    },
    resolve: {
      testModule: ['$ocLazyLoad','$stateParams' ,function($ocLazyLoad, $stateParams) {
        return $ocLazyLoad.load({
          name: 'remote',
          files: [endPointsProvider.getConfig().remote + '/assets-generated/remote.js?v=' + endPointsProvider.js_version()]
        });
      }]
    },
    cache:false
  })

   .state('order', {
    url: '/orders/view/:orderId',
    templateUrl: function($stateParams) {
      return endPointsProvider.getConfig().remote + '/angular/templates/app/myaccount/viewOrder.html'
    },
    resolve: {
      testModule: ['$ocLazyLoad','$stateParams' ,function($ocLazyLoad, $stateParams) {
        return $ocLazyLoad.load({
          name: 'remote',
          files: [endPointsProvider.getConfig().remote + '/assets-generated/remote.js?v=' + endPointsProvider.js_version()]
        });
      }]
    },
    controller: 'viewOrderController',
    cache:false
  })

  .state('checkout', {
    url: '/checkout/show',
    templateUrl: endPointsProvider.getConfig().remote + '/angular/templates/app/checkout/show.html',
    resolve: {
      testModule: ['$ocLazyLoad','$stateParams' ,function($ocLazyLoad, $stateParams) {
        return $ocLazyLoad.load({
          name: 'remote',
          files: [endPointsProvider.getConfig().remote + '/assets-generated/remote.js?v=' + endPointsProvider.js_version()]
        });
      }]
    },
    cache:false
  })

  .state('checkout.address',{
    views: {
      "address" : {
       templateUrl: endPointsProvider.getConfig().remote + '/angular/templates/app/checkout/address.html',
       controller: "addressController"
      }
    }
  })

  .state('checkout.confirmation',{
    views: {
      'confirmation': {
        templateUrl: endPointsProvider.getConfig().remote + '/angular/templates/app/checkout/confirmation.html',
        controller: 'confirmationController'
      }
    }
  })

  .state('checkout.payment',{
    views: {
      'payment': {
        templateUrl: endPointsProvider.getConfig().remote + '/angular/templates/app/checkout/payment.html',
        controller: 'paymentController'
      }
    }
  });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/');
  localStorageServiceProvider.setPrefix('infibeam');
  $ionicConfigProvider.tabs.position('top');
})

.run(function($ionicPlatform, $cordovaPush, $rootScope, $cordovaDialogs, $ionicPopup, $state, $ocLazyLoad, 
              babConfig, appRegistrationService, IBappHistoryService, $ionicBackdrop, cartService, 
              identityService, localStorageService, $location, $q, $timeout, $cordovaGoogleAnalytics, GA) {
  $ocLazyLoad.load({
    name: 'remote',
    files: [babConfig.host + '/assets-generated/remote.js?v=' + babConfig.js_version()]
  });

  $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams) {
    if (toState.resolve) {
      console.log('state change begun')
      if(!$rootScope.showSpinner) $rootScope.showSpinner = true;
    }
  });

  $rootScope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams) {
    if (toState.resolve) {
      console.log('state change ended')
      
      setTimeout(function(){ 
        if($rootScope.showSpinner) $rootScope.showSpinner = false;
      }, 100);
    }
    GA(function(){
      console.log('Pushing screen to GA ' + $location.$$url);
      $cordovaGoogleAnalytics.trackView($location.$$url);        
    });
  });

  $rootScope.stateChanging = function(){ return $rootScope.showSpinner };

  cartService.get_wishlist().then(function(result) {
    
    if (result !== 'error' && result !=null ) {
      var wishlistIds = "";
      if(result.list_items) {
        for(i = 0; i < result.list_items.length; i++){
          wishlistIds = wishlistIds + "|"+result.list_items[i].item_id;
        }
      }
      localStorageService.set("WishList",wishlistIds);
    }
  });

  q1 = $q.defer();
  q2 = $q.defer();
  q3 = $q.defer();
  p1 = q1.promise; 
  p2 = q2.promise;
  p3 = q3.promise;
 
  pAll = $q.all([
                  p1, 
                  p2,
                  p3
                ])
                .then(function(values) {        
                    console.log(values[2].platform, values[2].id, values[0].referrer, values[1].adId);
                    console.log("Calling appRegistrationApi");
                    appRegistrationService.registerApp(values[2].platform, values[2].id, values[0].referrer, values[1].adId);
                    return values;
                }, function(errors){
                  console.log(errors);
                  return errors;
                });

  identityService.getHeaderCartCount();
  $ionicPlatform.registerBackButtonAction(function (event) {
    var element = document.getElementsByClassName("ion-autocomplete-container")[0];
    if(element.style.display == "block") {
      $ionicBackdrop.release();
      element.style.display = "none";
      return;
    }
    if($location.path() !== "/")
    {  
      window.history.back();
      return; 
    }
    $ionicPopup.show({
      title: "Exit",
      template: "Do you want to exit app?",
      buttons: [
      {
        text: 'No',
        onTap : function(e){
          return false;
        }
      },
      {
        text: 'Exit',
        type: 'button-assertive',
        onTap : function(e){
          return true;
        }
      }
      ]
    })
    .then(function(result) {
      if(result) {
        ionic.Platform.exitApp();
      } else {
        popUp.close();
      }
    });
  }, 101);
  $ionicPlatform.ready(function() {
    if(window.StatusBar) {
      StatusBar.styleDefault();
    }
	
	if(window.plugins && window.plugins.webintent) {
		window.plugins.webintent.onNewIntent(onInvokeAppWithUrl);
		window.plugins.webintent.getUri(onInvokeAppWithUrl);
		function onInvokeAppWithUrl(url) {
			if(url && url!="") {
			  var webPath = url.split('infibeam.com')[1];
			  //regEx list
			  var webUrlRegEx = {};
			  webUrlRegEx['PDP1'] = /^\/([^\/]+)\/([^\/]+)\/(.*)-z.html?(.*)$/;
			  webUrlRegEx['PDP2'] = /^\/([^\/]+)\/([^\/]+)\/(.*).html?(.*)$/
			  //conditions
			  if(webUrlRegEx['PDP1'].test(webPath)) 
			  { //Check for web Detail Page url type 1
			    var regExMatch = webPath.match(webUrlRegEx['PDP1']);
			    var catalogId = regExMatch[3];
			    var variantId = regExMatch[4] ? regExMatch[4].split('variantId=')[1] : undefined;
			    $state.go('product', { 'catalog_id' : catalogId, 'variantId' : variantId });
			  }
			  else if(webUrlRegEx['PDP2'].test(webPath)) 
			  {  //Check for web Detail Page url type 2
			    var regExMatch = webPath.match(webUrlRegEx['PDP2']);
			    var catalogId = regExMatch[3];
			    var variantId = regExMatch[4] ? regExMatch[4].split('variantId=')[1] : undefined;
			    $state.go('product', { 'catalog_id' : catalogId, 'variantId' : variantId });
			  }
			  else
			  {
			    if(url.indexOf("infibeam-scheme://") === 0){
			      url = "/#" + url.split('infibeam.com')[1];
			    }
			    $state.go('webintend', { 'webUrl' : url });
			  }
			}
		}
	}

    $timeout( function() {
      console.log('resolving delayed promises');
      if(window.applicationPreferences) {
        window.applicationPreferences.get("referrer",
        function(value) {
          console.log("Referrer-value is " + value);
          q1.resolve({'referrer': value});
        },
        function(error) {
          console.log("Error! " + JSON.stringify(error));
          q1.resolve(error);
        });
      }
      if(window.cordova) cordova.require("cordova-plugin-android-idfa.androidIDFA").getAdId(function(obj){
        console.log(obj);
        q2.resolve(obj);        
      },function(error) {
        q2.reject(error)
      });

      if(window.device && window.device.platform == 'iOS') {
      var pushNotification = window.plugins.pushNotification;
      function tokenHandler (result) {
          console.log('device token: '+ result);
          // appRegistrationService.registerApp('iOS', result);
          q3.resolve({'platform': 'iOS', 'id': result});
          // This is a device token you will need later to send a push
          // Store this to PubNub to make your life easier :-)
      }

      function errorHandler(error){
        console.log("registration error");
        q3.reject(error);
      }

      pushNotification.register(
          tokenHandler, 
          errorHandler, 
          {
              'badge':'false',
              'sound':'false',
              'alert':'true',
              'ecb':'onNotificationAPN'
          }
      );

      var onNotificationAPN = function(event) {
        console.log(JSON.stringify(event));
        
        if( event.message ) {
          navigator.notification.confirm(event.message,function(buttonIndex){
            if(buttonIndex == 1)
              window.location.hash = event.url;  
          },event.title,['Proceed','Cancel']);
        }

        if ( event.sound && event.foreground != 1 ) {
            var snd = new Media(event.sound);
            snd.play();
        }

        if ( event.badge && event.foreground != 1 ) {
          pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, event.badge);
        }

      }

      if(typeof window.onNotificationAPN === 'undefined'){
          window.onNotificationAPN = onNotificationAPN;
      }
    }

    if(window.device && window.device.platform == 'Android') {
      var androidConfig = {
        "senderID" : babConfig.project_number,
      };
      
      $cordovaPush.register(androidConfig).then(function(result) {
        // Success
      }, function(err) {
        // Error
        q3.reject(err);
      })

      $rootScope.$on('$cordovaPush:notificationReceived', function(event, notification) {
        switch(notification.event) {
          case 'registered':
            // appRegistrationService.registerApp('GCM', notification.regid);
            q3.resolve({'platform': 'GCM', 'id': notification.regid});
            break;

          case 'message':
            // this is the actual push notification. its format depends on the data model from the push server
            $cordovaDialogs.alert(notification.message, notification.payload.title, 'Ok').then(function() {
              $location.url(notification.payload.url);
            });          
            break;

          case 'error':
            console.log('GCM error = ' + notification.msg);
            break;

          default:
            console.log('An unknown GCM event has occurred');
            break;
        }
      });
    }
    });
    
    console.log("Other Jobs continues"); 
  });
})
