angular.module('pnpAuthentication')
.controller('authCntrl', ['$scope','identityService', 'notificationService', '$stateParams', '$ionicModal', '$location', '$state', '$ionicPopup', '$cordovaFacebook',
	function($scope, idService, notificationService, $stateParams, $ionicModal, $location, $state, $ionicPopup, $cordovaFacebook) {
		$scope.user = {email:null,password:null,name:null};
		$scope.pwdInputType = "password";
		if($stateParams.redirectUrl) {
			idService.pushRedirectString($stateParams.redirectUrl);
		}

		$scope.login = function() {
			idService.login($scope.user).then(function(status) {
				if(status == "success") {
					$scope.proceedToNext();
				}
			})
		}

		$scope.googlelogin = function() {
			window.plugins.googleplus.login(
			    {
			    	'offline': true
			    },
			    function (obj) {
						$scope.loading = true;
						idService.loginByGoogle(obj).then(function(status) {
							if(status == "success") {
								$scope.proceedToNext();
							}
			      	// else alert(status + " - " + JSON.stringify(obj));
							$scope.loading = false;
						});
			    },
			    function (msg) {
			      // alert(JSON.stringify(msg));
			      $scope.loading = false;
			    }
			);
		}
		
		$scope.facebooklogin = function () {
			$cordovaFacebook.login(["public_profile"]).then(
				function(success) {
					$scope.loading = true;
					idService.loginByFacebook(success.authResponse.userID, success.authResponse.accessToken).then(function(status) {
						if (status == "success") {							
							$scope.proceedToNext();
						}
			      // else alert(status + " - " + JSON.stringify(success));
						$scope.loading = false;
					});
				}, function (error) {
					// alert(JSON.stringify(error));
					$scope.loading = false;
				}
			);
		}

		$scope.register = function() {
			idService.register($scope.user).then(function(status) {
				if(status == "success") {
					$scope.proceedToNext();
				}
			})
		}
		$scope.logout = function() {
			idService.logout().then(function(status){
				if(status == "success")
					idService.user = null;
			});
		}

		$scope.showPassword = function() {
			if($scope.pwdInputType == 'password') {
				$scope.pwdInputType = 'text';
			}
			else {
				$scope.pwdInputType = 'password';
			}
		}

		$scope.forgotPwd = function() {
			idService.forgotPwd($scope.forgot_pwd_data).then(function(status) {
				if (status === "success") {
					notificationService.add('Reset link sent to your mail')
				}
			})
		};

  	$scope.resetPwdForm = {new_password:null,confirm_new_password:null};
  	$scope.resetPassword = function() {
  		$scope.resetPwdForm['verification_code'] = $stateParams.verificationCode;
  		idService.resetPwd($scope.resetPwdForm).then(function(status) {
			if(status == "success") {
				$scope.proceedToNext();
			}
		})	  		
  	}

		$scope.proceedToNext = function() {
			if(idService.redirectUrl){
				$location.url(idService.popRedirectString());
			}
			else {
				$state.go('home');
			}
		}
		$scope.ForgotpwdPopup = function() {
		  $scope.forgot_pwd_data = {}

		  // An elaborate, custom popup
		  var FP_Popup = $ionicPopup.show({
		    template: '<h3 class="popup-title ng-binding" ng-bind-html="title"></h3><h5 class="popup-sub-title ng-binding" ng-bind-html="subTitle" ng-if="subTitle"></h5><input type="email" ng-model="forgot_pwd_data.email" placeholder="Email Id" autofocus>',
		    title: 'Forgot Password',
		    subTitle: 'Please enter your email address below. You will receive  a link to reset  your password',
		    scope: $scope,
		    buttons: [
		      { text: 'Cancel' },
		      {
		        text: '<b>Send Email</b>',
		        type: 'button-positive',
		        onTap: function(e) {
		          if (!$scope.forgot_pwd_data.email) {
		            //don't allow the user to close unless he enters email
		            e.preventDefault();
		          } else {
		            $scope.forgotPwd();
		          }
		        }
		      }
		    ]
		  });
		};

	}
])
