angular.module('pnpCart')
.controller('cartCntrl', ['$scope', '$state', 'cartService', '$ionicPopup', 
	'$ionicTabsDelegate', '$ionicModal', '$timeout', '$rootScope', '$cordovaInAppBrowser',
	'infibeamCheckoutService','$cordovaToast', '$filter',
	function($scope, $state, cartService, $ionicPopup, $ionicTabsDelegate, 
		$ionicModal, $timeout, $rootScope, $cordovaInAppBrowser, infibeamCheckoutService, $cordovaToast, $filter) {

		$scope.startCheckout = function() {
			cartService.set_checkout_flags();
			infibeamCheckoutService.createPurchase().then(function(response) {
				cartService.reset_checkout_flags();
				if (response.meta !== undefined && response.meta.result === "success") {
					$state.go('checkout');					
				} else {
					$cordovaToast.showLongTop("Error while starting checkout. Please try after some time.");
				}
			});
	    }

	 	$scope.init = function() {
	 		if (cartService.redirect_to_checkout()) {
	 			cartService.reset_checkout_flags();
	 			$scope.startCheckout();
	 		}
	      	cartService.getShowCart();
	      	cartService.get_save_for_later();
			$ionicTabsDelegate.select(0);
		}	

		$scope.init();
		$scope.couponCode = {"value": ""};
	   
	    $scope.cart_type = function() {
	    	return cartService.cart_type;
	    }

	    $scope.cartCount = function() {
	    	
	    	if(cartService.getCartItemCount() > 0) {
	    		return "( " + cartService.getCartItemCount()+ " )";
	    	}
	    	else {
	    		return "";
	    	}
	    }
	    $scope.getCartSummary = function() {
	    	return cartService.cart_summary;
	    }
	    $scope.savedCount = function() {
	    	if(cartService.getSavedItemCount() > 0) {
	    		return "( " + cartService.getSavedItemCount() + " )";
	    	}
	    	return "";
	    }
	    $scope.isLoading = function() {
	    	return cartService.isLoading;
	    }
	    $scope.yousave_value = function(cartItem) {
	    	if(cartItem.variant.promotions.length > 0) {
	    		return ((cartItem.variant.base_price.value - cartItem.variant.final_price.value)*cartItem.quantity)+
	    					(cartItem.variant.promotions[0].amount.value);		
	    	}
	    	else {
	    		return ((cartItem.variant.base_price.value - cartItem.variant.final_price.value)*cartItem.quantity);
	    	}
	    }
	   
			$scope.savelist_type = function() {
	    	return cartService.savelist_type;
	    }

	    $scope.getCartItems = function() {
	    	return (cartService.cart_items !== undefined)?(cartService.cart_items):([]);
	    }

	    $scope.getSavedItems = function() {
	    	return (cartService.saved_items !== undefined)?(cartService.saved_items):([]);
	    }
	  
      $scope.getPromoCodes = function() {
      	return (cartService.promotion_list !== undefined)?(cartService.promotion_list):([]);
      }
      $scope.getAppliedCoupon = function() {
      	return (cartService.applied_coupon_list !== undefined)?(cartService.applied_coupon_list):([]);
      }
      $scope.addCoupon = function(couponCode) {
        cartService.applyCoupon(couponCode).then(function(response) {
	        if(response) {
					 	$scope.closeModal();
	        }
        });
				
      }
      $scope.removeCoupon = function(couponCode) {
        cartService.removeCoupon(couponCode);
      }
      $scope.getCouponValidity = function(variant) {
        valString = "Valid ";
        if(variant.promotions != null && variant.promotions[0] != null) {
        	var end_date = new Date(variant.promotions[0].end_date);
        	var today = new Date();
        	var timeDiff = Math.abs(end_date.getTime() - today.getTime());
					var diffDays = Math.floor(timeDiff / (1000 * 3600 * 24)); 
        	if(diffDays > 1) {
        		valString += "for "+ diffDays + " days.";
        	}
        	else {
        		valString += "for TODAY only!";
        	}
        return valString;
        }
        return "";
      }
	    $scope.deletefromcart = function(listingId) {
	    	var formData = {'list_type':'shopping_cart', 'listing_id':listingId};
	    	cartService.delete_item(formData).then(function(result) {
	    		if (result !== 'error') {
	    		}
	    	});
	    }
	    $scope.deletefromsavelist= function(listingId) {
	    	var formData = {'list_type':'save_for_later', 'listing_id':listingId};
	    	cartService.delete_item(formData).then(function(result) {
	    		if (result !== 'error') {
	    		}
	    	});
	    }
	    $scope.moveItemfromcart2savelist = function(listingId) {
	    	var formData = {'listing_id':listingId, 'from_list_type':'shopping_cart', 'to_list_type':'save_for_later'};
	    	cartService.move_item(formData).then(function(result) {
	    		if (result !== 'error') {
	    		}
	    	});
	    } 	   
	    $scope.moveItemfromsavelist2cart = function(listingId) {
	    	var formData = {'listing_id':listingId, 'from_list_type':'save_for_later', 'to_list_type':'shopping_cart'};
	    	cartService.move_item(formData).then(function(result) {
	    		if (result !== 'error') {
	    		}
	    	});
	    } 	   
	    $scope.updateItem = function(listingId, quantity) {
	    	var formData = {'listing_id':listingId, 'list_type':'shopping_cart', 'quantity': quantity};
	    	cartService.update_item(formData).then(function(result) {
	    		if (result !== 'error') {
	    		}
	    	});
	    }
	    $scope.isItemsNotAvailable = function() {
	    	var items = cartService.cart_items;
				for (var i = items.length - 1; i >= 0; i--) {
					if((items[i].quantity > items[i].variant.available_quantity) || 
							(items[i].variant.buy_status != 'buy')) {
								return true;
					}
				}
				return false;
			}
      $scope.goBack = function() {
        $state.go('home');
      }
      $ionicModal.fromTemplateUrl('lib/pnp-cart/templates/coupon.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });
      $scope.openModal = function() {
        $scope.modal.show();
      };
      $scope.closeModal = function() {
      	cartService.cart_errormsg = "";
        $scope.modal.hide();
      };
      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hidden', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.showPopup = function(listing_id) {
		    // An elaborate, custom popup
		    $scope.myPopup = $ionicPopup.show({
		      template: '<button ng-click="myPopup.close()" style="float: right" class="button button-small button-icon icon ion-ios-close-outline"></button></br>You can save this item for later or remove and proceed to checkout',
		      title: '',
		      subTitle: '',
		      scope: $scope,
		      buttons: [
		      	{ text: 'SAVE FOR LATER', 
		         	type: 'button-small button-positive',
		         	onTap: function(e) {
		           	$scope.moveItemfromcart2savelist(listing_id);
		        	}
		      	},
		       	{
		         	text: 'REMOVE',
		         	type: 'button-small',
		         	onTap: function(e) {
		           	$scope.deletefromcart(listing_id);
		        	}
		       	},
		     	]
		   	});
		   	$scope.myPopup.then(function(res) {
		     	//console.log('Tapped!', res);
		   	});
		   	// $timeout(function() {
		    // 	myPopup.close(); //close the popup after 3 seconds for some reason
		   	// }, 3000);
		  };
		  $scope.cartError = function() {
        return cartService.cart_errormsg;
      };

	}
])
.directive('cartSummary', function(){
	return {
		restrict: 'E', 
		templateUrl: 'lib/pnp-cart/templates/cart-summary.html',
	};
})
.filter('range', function() {
  return function(input, total) {
    total = parseInt(total);
    total = (total > 10)? 10: total;
    for (var i=1; i<=total; i++)
      input.push(i);
    return input;
  };
});
