pnpCore = angular.module('pnpCore', ['ionic', 'restangular','ngCordova'])

.config(function (RestangularProvider){
  RestangularProvider.setRequestSuffix('.json');
  RestangularProvider.setDefaultHeaders({
    'Content-Type': 'application/json',
    'X-Requested-With': 'XMLHttpRequest'
  });
  RestangularProvider.setDefaultHttpFields({
      'withCredentials': true
  });

  RestangularProvider.setResponseExtractor(function(response) {
     if(response.result == undefined) {
      return response;
    }
    if(response.meta != undefined) {
      response.result.meta = response.meta;
    }
    return response.result;
  });

  RestangularProvider.setErrorInterceptor(function(response, deferred, responseHandler) {    
    if (response.status === 401) {      
      window.location.href='#/authenticate';
      return false;
    }
    return true;
  });

  RestangularProvider.addResponseInterceptor (
  function (data, operation, what, url, response, deferred) {
    console.log("returning ..",url,response.status);
    return data;
 })

 RestangularProvider.addFullRequestInterceptor (
  function (element, operation, route, url, headers, params, httpConfig) {
    console.log("calling ..",url,JSON.stringify(params));
    return {};
 })



RestangularProvider.setErrorInterceptor(function(response, deferred, responseHandler) {
  console.log("error",response.status, JSON.stringify(response));
    return true; // error not handled
});
})





