pnpCore

.service('browseNodeService',['babRA', function (babRA) {

	var searchRA = babRA;
	var whitelisted_q_params = ['prop.q','prop.predict','prop.top_categories'];
	var bns=this;
	bns.sresults=null;
	bns.current_bn="home";
	bns.current_page=1;
	bns.querry={};
	
	///// ----- Init functions ----- /////
	bns.init_search = function(){
		bns.search_page(0);
	}

	bns.init_facets = function(){
		bns.selected_filters={};
		bns.facet_object = null;
	}

	/////  ----- Pre search functionality -----  /////	

	bns.preload_selected = function(){
		var facet_list= bns.facets();
		_(facet_list).forEach(function(facet){
			var facet_name='prop.'+facet.code;
			var facet_values= _(facet.facet_values)
			.filter( {selected: true})
			.pluck("code")
			.values();
			bns.multi_select(facet_name,facet_values);
		});
	}	

	/////  ----- Search Function -----  /////


	bns.querry_cleaup = function(){
		var querry_filters = {};
		angular.copy(bns.querry,querry_filters);
		var  querry_hash = {};
		_(whitelisted_q_params).forEach(function(key){
			if(bns.querry[key]){
				querry_hash[key]=bns.querry[key];
			}
		})
		bns.querry={};
		bns.querry = querry_hash;
	}

	bns.search_page = function(page_num){
		var filters = bns.search_filters();
		filters['prop.page']=page_num;

		return searchRA
		.one('browse-nodes', bns.current_bn)
		.customGET('search', filters)
		.then(function(object){
			if(page_num==1){
				bns.sresults = object;
				bns.preload_selected();
			}
			else if(page_num == -1){
				bns.facet_object = object;
			}
			return object;
		});
	}

	bns.get_facet_list = function(){
		if(bns.facet_object){
			return bns.get_sort_options().concat(bns.facet_object.facets.facet_list);
		}
		else if(bns.sresults){
			return bns.get_sort_options().concat(bns.sresults.facets.facet_list);
		}
		else{
			return [];
		}
	}

	bns.get_facet_current_bn = function(){
		if(bns.facet_object){
			return bns.facet_object.curr_bn;
		}
		else if(bns.sresults){
			return bns.sresults.curr_bn;
		}
		else{
			return {};
		}
	}

	/////  -----Setter functions-----	/////

	bns.set_querry = function(query){
		query_hash={};
		_(query).forEach(function(value,key){
			var v=value;
			var k=key;
			if(k.indexOf('prop')<0){
				k='prop.'+k
			}
			query_hash[k]=v;
		})
		bns.querry = query_hash;
	} 

	bns.set_bn = function(bn_url){
		bns.current_bn = bn_url;
	}

	bns.toggle = function(facet_name,facet_value){
		bns.selected_filters[facet_name] = (bns.selected_filters[facet_name]||[]);
		selected_filters = bns.selected_filters[facet_name];
		if( _.contains(selected_filters,facet_value)) {
			_.pull(bns.selected_filters[facet_name],facet_value);
		}
		else {
			bns.selected_filters[facet_name].push(facet_value);
		}
	}

	bns.toggle_single_select = function(facet_name,facet_value){
		bns.selected_filters[facet_name] = [];
		bns.selected_filters[facet_name].push(facet_value);
	}
	
	bns.multi_select = function(facet_name,facet_values){
		bns.selected_filters[facet_name] = (bns.selected_filters[facet_name]||[]);
		bns.selected_filters[facet_name] = _.union(bns.selected_filters[facet_name],facet_values.value());
	}

	/////  -----Getter functions-----  /////
	bns.querry_string = function(){
		return bns.querry['prop.q']==undefined ? '' : bns.querry['prop.q'];
	}

	bns.current_browse_node = function(){
		if(bns.sresults!=null && bns.sresults.curr_bn){
			return bns.sresults.curr_bn;
		}
		else{
			return null;
		}
	}
	
	bns.num_results = function(){
		if(bns.sresults!=null){
			return bns.sresults.number_of_results;
		}
		else{
			return 0;
		}
	}

	bns.browse_nodes = function(){
		if(bns.facet_object && bns.facet_object.bn_children){
			return bns.facet_object.bn_children.children;
		}
		else if(bns.sresults && bns.sresults.bn_children){
			return bns.sresults.bn_children.children;
		}
	}

	bns.selection = function(key){
		return bns.selected_filters;
	}

	bns.variants = function(){
		if(bns.sresults!=null){
			return bns.sresults.variants;
		}
	}

	bns.search_filters = function(){
		var querry_filters ={};
		angular.copy(bns.selected_filters,querry_filters);
		_(bns.querry).forEach(function(value,key){
			if(!querry_filters[key]){
				querry_filters[key]=[];
				querry_filters[key].push(value);
			}
			else{
				if(querry_filters[key].indexOf(value)<0){
					querry_filters[key].push(value);
				}
			}
		})
		return querry_filters;
	}

	bns.get_sort_options = function(){
		var sort_selection = bns.sresults.current_sort_option;
		var sort_options = bns.sresults.other_sort_options;
		if(sort_selection && sort_options){
			var sort_hash = [{
			"type": "SingleSelect",
	        "name": "SortOrder",
	        "code": "sort"
	        }];

	        sort_hash[0]['facet_values'] = [];
			_(sort_options).forEach(function(opt){
				opt_struct = {};
				opt_struct['code'] = opt;
				if(opt == 'asc'){
					opt_struct['name'] = 'Ascending';
				}
				else if(opt == 'desc'){
					opt_struct['name'] = 'Descending';
				}
				else if(opt == 'relevance'){
					opt_struct['name'] = 'Relevance';
				}

				if(opt == sort_selection){
					opt_struct['selected'] = true;
				}
				else{
					opt_struct['selected'] = false;
				}
				opt_struct['enabled'] = true;
				
				sort_hash[0]['facet_values'].push(opt_struct);
			});
			return sort_hash;
		}
		return [];
	}

	
	bns.facets = function(){
		if(bns.sresults!=null && bns.sresults.facets){
			return bns.get_sort_options().concat(bns.sresults.facets.facet_list);
		}
	}

	bns.get_facet_obj = function(){
		return bns.facet_object;
	}

	bns.pre_selected_facet_vals = function(facet){
		var selected_vals = [];
		selected_vals = _.filter(facet.facet_values,{selected:true});
		selected_vals = _.sortBy(selected_vals,'name');
		return selected_vals;
	}

	bns.selected_facet_vals = function(facet){
		if(facet){
			return bns.selected_filters['prop.'+facet.code];
		}
		else{
			[];
		}
	}

	bns.facet_summary = function(){
		if(bns.sresults && bns.sresults.facets){
			var selected_facets = bns.sresults.facets.selected_summary;
			facet_vals=[];
			_(selected_facets).forEach(function(facet){
				facet_vals.push(facet['value']);
			})
			return facet_vals;
		}
		else{
			return [];
		}
	}

	bns.pre_unselected_facet_vals =  function(facet){
		var unselected_vals = [];
		unselected_vals = _.pull(facet.facet_values,{selected:true});
		unselected_vals = _.sortBy(unselected_vals,'name');
		return unselected_vals;	
	}

	
	bns.top_categories = function(){
		if(bns.sresults!=null){
			return bns.sresults.top_categories;
		}
	}
}]);
