pnpCore
.service('cartService', ['babRA', '$state', 'localStorageService', '$rootScope', function(babRA, $state, localStorageService, $rootScope) {
	var cartRA = babRA.withConfig(function(RestangularConfigurer) {
		RestangularConfigurer.addElementTransformer('cart', false, function (result) {
			return result;
		});
	});

	var cas = this;
	cas.cart_items = [];
	cas.saved_items = [];
	cas.cart_type = "";
	cas.savelist_type = "";
	cas.promotion_list = [];
	cas.applied_coupon_list = [];
	cas.cart_summary= [];
	cas.cart_errormsg = "";
	cas.isLoading = false;
	cas.proceed_to_checkout = false;
	cas.previous_cart_items_count = -1;
	$rootScope.cart_count = null;
	cas.getShowCart = function() {
		cas.isLoading = true;
		return cartRA.one('my-save-lists','random').customGET('showCart').then(function(response){
			cas.cart_items = response.list_items;
			cas.cart_type = response.list_type;
			cas.promotion_list = (response.promo_messages !== undefined)?(response.promo_messages):([]);
			cas.applied_coupon_list= response.coupons;
			cas.cart_summary['value_before_promotion'] = response.total_value + response.total_promotion;
			cas.cart_summary['total_promotion'] = response.total_promotion;
			cas.cart_summary['value_after_promotion'] = response.total_value;
			cas.isLoading = false;
			$rootScope.cart_count = cas.getCartItemCount();
		});
	}
	cas.get_save_for_later = function() {
		return cartRA.one('my-save-lists','random').customGET('showSaveForLater').then(function(response) {
			cas.saved_items = response.list_items;
			cas.savelist_type = response.list_type;
		});
	}

	cas.get_wishlist = function() {
		return cartRA.one('my-save-lists','WishList').customGET('show').then(function(response) {
			return response;
		});
	}
	cas.add_to_cart = function(formData) {
		return cartRA.one('my-save-lists', 'random').customPOST(formData,'addToList').then(function(response) {
			return response;
		});
	}
	cas.delete_item = function(formData) {
		return cartRA.one('my-save-lists','random').customPOST(formData,'deleteFromList').then(function(response) {
			cas.getShowCart();
			cas.get_save_for_later();
		});
	}
	cas.move_item = function(formData) {
		return cartRA.one('my-save-lists','random').customPOST(formData,'moveFromList').then(function(response){
			cas.getShowCart();
			cas.get_save_for_later();
		});	
	}
	cas.update_item = function(formData) {
		return cartRA.one('my-save-lists','random').customPOST(formData,'updateList').then(function(response){
			cas.getShowCart();
			cas.get_save_for_later();
		});
	}
	cas.get_auth_token = function() {
		return cartRA.one('auth-token-generator','random').customGET('token');
	}
	cas.getTotalCartValue = function() {
		var total_value = 0;
		for (var index in cas.cart_items) {
			total_value += cas.cart_items[index].variant.final_price.value;
		}
		return total_value;
	}
	cas.getCartItemCount = function() {
		return cas.cart_items? cas.cart_items.length: 0;
	}
	cas.getSavedItemCount = function() {
		return cas.saved_items? cas.saved_items.length: 0;
	}
	cas.applyCoupon = function(couponCode) {
		return cartRA.one('my-save-lists','random').customGET('showCart',{"couponCode": couponCode}).then(function(response){
			if(response.error_messages!= null){
				cas.cart_errormsg = response.error_messages[0];
				return false;
			}
			else {
				cas.cart_errormsg = "";
				cas.cart_items = response.list_items;
				cas.cart_type = response.list_type;
				cas.promotion_list = (response.promo_messages !== undefined)?(response.promo_messages):([]);
				// temp = {"promotion_code": "Winter10", "message": "Get 10% offer in this winter"};
				// cas.promotion_list.push(temp);
				cas.applied_coupon_list= response.coupons;
				cas.cart_summary['value_before_promotion'] = response.total_value + response.total_promotion;
				cas.cart_summary['total_promotion'] = response.total_promotion;
				cas.cart_summary['value_after_promotion'] = response.total_value;
				return true;
			}
		});
	}	
	cas.removeCoupon = function(couponCode) {
		cartRA.one('my-save-lists','random').customGET('removeCouponCode',{"couponCode": couponCode}).then(function(response){
			if(response.coupons == undefined){
				cas.cart_items = response.list_items;
				cas.cart_type = response.list_type;
				cas.promotion_list = (response.promo_messages !== undefined)?(response.promo_messages):([]);
				// temp = {"promotion_code": "Winter10", "message": "Get 10% offer in this winter"};
				// cas.promotion_list.push(temp);
				cas.applied_coupon_list= response.coupons;
				cas.cart_summary['value_before_promotion'] = response.total_value + response.total_promotion;
				cas.cart_summary['total_promotion'] = response.total_promotion;
				cas.cart_summary['value_after_promotion'] = response.total_value;
				return true;
			}
			else {
				return false;
			}
		});
	}
	cas.set_checkout_flags = function()  {
		cas.proceed_to_checkout = true;
		cas.previous_cart_items_count = cas.getCartItemCount();		
	}
	cas.reset_checkout_flags = function() {
		cas.proceed_to_checkout = false;
		cas.previous_cart_items_count = -1;
	}
	cas.redirect_to_checkout = function() {
		if (cas.proceed_to_checkout && cas.previous_cart_items_count != -1
			&& cas.previous_cart_items_count == cas.getCartItemCount()) {
			return true;
		} else {
			return false;
		}
	}	
}]);