angular.module('pnpHeader', ['pnpCore'])

.directive('ibHeaderMain',['babRA', '$state', 'localStorageService', function (babRA, $state, localStorageService) {
	var ibHeaderMain = {};
	ibHeaderMain.replace = true;
	ibHeaderMain.restrict = 'EC';
	ibHeaderMain.templateUrl = "lib/pnp-header/templates/header.html";
	ibHeaderMain.controller = function($scope, $state, $ionicHistory){
		
		$scope.goToCart = function() {
			$state.go('cart');
		}
	}
	return ibHeaderMain;
}])

.directive('ibSideBarMain', ['identityService', 'pageViewService', '$location', 'babConfig', '$location', function(idService, pageViewService, $location, babConfig, $location){
	var ibSideBarMain = {};
	ibSideBarMain.replace = true;
	ibSideBarMain.restrict = 'EC';
	ibSideBarMain.templateUrl = "lib/pnp-header/templates/side-bar.html";
	ibSideBarMain.controller = function($scope, $state, $ionicHistory, $location) {

	  //function to convert camelcase to dashed notation
	  function camelToDash(str) {
	    return str.replace(/\W+/g, '-').replace(/([a-z\d])([A-Z])/g, '$1-$2').toLowerCase();
	  }

	  $scope.nav_widgets_page_url = babConfig.menu_page;

		//Get Page from pageService
	  pageViewService.show($scope.nav_widgets_page_url, false).then(function(object) {
		  $scope.menu_widgets = object.widgets;
	    _($scope.menu_widgets).forEach(function(widget){
	      widget.ng_class_name = camelToDash('ib' + widget.type)
	      widget.viewType = 'menutype';
	    });
		});

	  $scope.currentTab = 0;

		$scope.selectTab = function(index){
			$scope.currentTab = index;
		}

		$scope.toggleTab = function(){
			$scope.currentTab = $scope.currentTab == 1 ? 0 : 1;
		}		

		$scope.currentUrl = function() {
			return $location.url()
		};
		$scope.isLoggedIn = function() {
			return idService.isLoggedIn();
		};
		$scope.logout = function() {
			idService.logout().then(function(status){
				if(status == "success" || status == "error") {
					idService.user = null;
					$scope.welcome_string = "";
					$scope.selectTab(0);
					$state.go('home');
				}
			});
		};
		$scope.welcome_string = "";
		$scope.getUserName = function() {
		  if($scope.welcome_string == "") {
		  	var random_string = ['Hello','Hi','Hola','Namaste','Wassup','Namaskar','Salut','Hallo','Vanakkam','salaam','Welcome'];
				var rnum = Math.floor((Math.random()*10));
				if(idService.getUser().name) {
					$scope.welcome_string = random_string[rnum]+ " " + idService.getUser().name;
				}
				else {
					$scope.welcome_string = random_string[rnum]+ " User";
				}
		  }
			return $scope.welcome_string;
		}
	}
	return ibSideBarMain;
}])

.directive('stopAnimation', ['$compile', '$ionicHistory', function($compile, $ionicHistory){
  return{
    restrict: 'A',
    link: function(scope, element){
      element.bind("click", function(e){
	  		$ionicHistory.nextViewOptions({
          disableAnimate: true
        });
      });
    }
	}
}])

.directive('backButton', ['$location', function($location){
	var class_condition = "{ 'icon ion-ios-arrow-back': (hasBack()), 'spinning' : $root.stateChanging() }";
	var back = {};
	back.restrict = 'EA';
	back.controller = function($scope){
		$scope.backUrl = function(){
			window.history.back();
		};
		$scope.hasBack = function(){
			return $location.path() !== "/"
		};
	};
	back.replace = true;
	back.template = '<a class="button no-border ib-logo" ng-click="backUrl()" ng-class="' + class_condition + '"></a>'
	return back;
}])

.directive('ibMenuToggle', function() {
  return {
    restrict: 'AC',
    link: function($scope, $element, $attr) {

      $element.bind('click', function() {
        var sideMenuCtrl = $element.inheritedData('$ionSideMenusController');
        sideMenuCtrl && sideMenuCtrl.toggle($attr.ibMenuToggle);
      });
    }
  };
});