angular.module('pnpProduct')

.directive('catalogoptions', function(){
  var co = {};
  co.restrict = 'E';
  co.transclude = true;
  co.controller = function($scope, $ionicPopover){

  };

  co.templateUrl = "lib/pnp-product/templates/catalog-options.html";
  return co;
})

.directive('catalogOptionsPopover',function(){
  var copo = {};
  copo.restrict = 'E';
  copo.scope = {
    co_ordering: '=ordering',
    co: '=option'
  };
  copo.templateUrl = "lib/pnp-product/templates/catalog-options-popover.html";
  copo.controller = function($scope, $ionicPopover){

    //option popover methods begin
    $scope.openPopoverOptions = function() {
      $ionicPopover.fromTemplateUrl('popover_options.html', {
        scope: $scope
      }).then(function(popover_options) {
        $scope.popover_options = popover_options;
        $scope.popover_options.show();
      });
    };

    $scope.closePopoverOptions = function() {
      $scope.popover_options.hide();
      $scope.popover_options.remove();
    }; //option popover methods end

  };
  return copo;
})

.directive('catalog', ['$state', 'imageResSrcFix', 'productReviewsService', function($state, imageResSrcFix, productReviewsService) {
  return{
    scope:{
      catalog: '='      
    },
    controller: function($scope, $ionicModal, $ionicScrollDelegate) {
      $scope.change_img = function(image_id) {
        $scope.catalog.set_current_image(image_id);
      }

      $scope.share_product = function(){
        if($scope.variant.web_link != undefined){
          window.plugins.socialsharing.share('Infibeam product you might be interested in: ', 'Infibeam trending product', $scope.catalog.current_image.medium, $scope.variant.web_link);
        }
      }

      $scope.imageZoom = function() { //for tap zoom
        var zoomFactor = 1.25;
        $ionicScrollDelegate.$getByHandle('image-zoom').zoomBy(zoomFactor);
      }

      $scope.Modal = {};
      $scope.Tab = {};
      $scope._ = window._;
      $scope.imageResSrcFix = imageResSrcFix;

      //tab methods
      $scope.openTab = function(opt){
        $scope.Tab[opt + '_show'] = true;
      }

      $scope.closeTab = function(opt){
        $scope.Tab[opt + '_show'] = false;
      }

      $scope.toggleTab = function(opt){
        if($scope.Tab[opt + '_show']){
          $scope.closeTab(opt);
        }
        else{
          $scope.openTab(opt);
        }
      }

      $scope.isTabShown = function(opt){
        return $scope.Tab[opt + '_show'];
      }

      //modal methods
      $scope.openModal = function(opt){
        if(!$scope.Modal[opt])
        {
          $ionicModal.fromTemplateUrl('lib/pnp-product/templates/product-'+ opt +'.html', {
            scope: $scope,
            animation: 'slide-in-up'
          }).then(function(modal) {
            $scope.Modal[opt] = modal;
            $scope.Modal[opt].show();
          });     
        }
        else  $scope.Modal[opt].show();
      }

      $scope.closeModal = function(opt){
        $scope.Modal[opt].hide();
        $scope.Modal[opt].remove();
        delete $scope.Modal[opt];
      }

      $scope.openReviewsModal = function(){
        $scope.toggleTab('reviews');
        if(!$scope.catalog.reviews){
          productReviewsService.show($scope.catalog.sku).then(function(reviews){
            $scope.catalog.reviews = reviews;
          })
        }
      }

      $scope.closeReviewsModal = function(){
        $scope.closeModal('reviews');
      }

      $scope.openImageModal = function(){
        if(!$scope.Modal['image-preview']) {
          $ionicModal.fromTemplateUrl('lib/pnp-product/templates/image-modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
          }).then(function(modal) {
            $scope.Modal['image-preview'] = modal;
            $scope.Modal['image-preview'].show();
          });
        }
        else $scope.Modal['image-preview'].show();
      }

      $scope.closeImageModal = function(){
        $scope.Modal['image-preview'].hide();
        $scope.Modal['image-preview'].remove();
        delete $scope.Modal['image-preview'];
      } //modal methods end

    },
    restrict: 'A',
    transclude:true,
    link: function(scope, elem, attr, nullCtrl, transclude){
      scope.$watch('catalog.current_variant', function(){
        if(scope.catalog) {
          scope.co_ordering = scope.catalog.co_ordering;
          scope.pre_visits = scope.catalog.pre_visits;
          scope.variant = scope.catalog.current_variant;
          scope.selected_variant = _.find(scope.catalog.variants_path_map, { 'id': scope.variant.sku });
        }
      });
      transclude(scope, function(clone){
        elem.append(clone);
      });
    }
  }
}])

.directive('ibZipCheck', ['zipCheckService', function(zipCheckService){
  return {
    restrict: 'A',
    controller: function($scope){

      $scope.givenZip = undefined;
      $scope.zipStatus = undefined;
      $scope.zipFormatCheck = function(){
        return /^(\d{6})$/.test($scope.givenZip);
      }
      $scope.checkZip = function(){
        zipCheckService.get($scope.givenZip,$scope.variant.sku).then(function(option){
          $scope.zipStatus = option;
        });
      }
    }
  }
}])

.directive('variant', ['$state', 'cartService', 'infibeamCheckoutService', function($state, cartService, infibeamCheckoutService){
  return{
    scope:{
      variant: '='
    },
    restrict: 'A',
    transclude:true,
    link: function(scope, elem, attr, nullCtrl, transclude){
      transclude(scope, function(clone){
        elem.append(clone);
      });
    },
    controller: function($scope, $ionicModal, $ionicPopover, $ionicPopup, notificationService, localStorageService, notifyMeService) {

      //emi models and methods
      $scope.emi = {};
      $scope.emi.inview = {};
      $scope.emi.inview.bank = null;
      $scope.emi.inview.month = null;
      $scope.emi.bankOptionChanged = function(){
        $scope.emi.inview.month = $scope.emi.inview.bank && $scope.emi.inview.bank.emiDetails.length ? $scope.emi.inview.bank.emiDetails[0] : $scope.emi.inview.month;
        return $scope.emi.inview.month ? true : false;
      }
      $scope.emi.openModal = function(){
        $scope.emi.inview.bank = $scope.variant.emi_info.length && !$scope.emi.inview.bank ? $scope.variant.emi_info[0] : $scope.emi.inview.bank;
        $scope.emi.bankOptionChanged();
        $scope.openModal('emi');
      }
      $scope.emi.closeModal = function(){ $scope.closeModal('emi'); }
      //emi option popover methods begin
      $scope.emi.openPopover = function(opt) {
        var option_hash = { 'banks' : 'popover_emi.html', 'months' : 'popover_emi_months.html' };
        $ionicPopover.fromTemplateUrl(option_hash[opt], {
          scope: $scope
        }).then(function(popover_options) {
          $scope.emi.popover = popover_options;
          $scope.emi.popover.show();
        });
      };

      $scope.emi.closePopover = function() {
        console.log($scope.emi.inview);
        $scope.emi.popover.hide();
        $scope.emi.popover.remove();
      }; //emi option popover methods end

      //notify me stuff
      $scope.notifyMe = {};

      $scope.notifyMe.email = null;
      $scope.notifyMe.mobile = null;
      $scope.notifyMe.show_popup = function() {
        var custInfo = localStorageService.get('IbCustInfo');
        if(custInfo){
          $scope.notifyMe.email = !custInfo.email ? '' : custInfo.email;
          $scope.notifyMe.mobile = !custInfo.mobile ? '' : Number(custInfo.mobile.split('-')[1]);
        }

        var popupTemplate = [];
        popupTemplate.push('<div class="list list-inset">');
        popupTemplate.push('<label class="item item-input">');
        popupTemplate.push('<input type="text" placeholder="E-Mail" ng-model="notifyMe.email">');
        popupTemplate.push('</label>');
        popupTemplate.push('</div>');
        
        var myPopup = $ionicPopup.show({
          template: popupTemplate.join('\n'),
          title: 'Enter Email & Mobile',
          cssClass: 'notify-popup',
          scope: $scope,
          buttons: [
            { 
              text: 'Cancel',
              onTap: function(e){ return false; } 
            },
            {
              text: '<b>OK</b>',
              type: 'button-positive',
              onTap: function(e) {
                if (!$scope.notifyMe.email) {
                  //don't allow the user to close unless he enters wifi password
                  e.preventDefault();
                } else {
                  return true;
                }
              }
            }
          ]
        });
        myPopup.then(function(result) {
          if(result){
            var query = {
              "listing_id": $scope.variant.sku,
              "listing_status": $scope.variant.item_availability,
              "email": $scope.notifyMe.email,
              "mobile": $scope.notifyMe.mobile
            };
            notifyMeService.notifyTo(query).then(function(res){
              if(res.meta && res.meta.message)
                notificationService.add('You will be notified when the item becomes available!');
              myPopup.close();
            })
          }
          else{
            myPopup.close();
          }
        });
      }

      //modal methods
      $scope.Modal = {};

      $scope.openModal = function(opt){
        if(!$scope.Modal[opt])
        {
          $ionicModal.fromTemplateUrl('lib/pnp-product/templates/product-'+ opt +'.html', {
            scope: $scope,
            animation: 'slide-in-up'
          }).then(function(modal) {
            $scope.Modal[opt] = modal;
            $scope.Modal[opt].show();
          });     
        }
        else  $scope.Modal[opt].show();
      }

      $scope.closeModal = function(opt){
        $scope.Modal[opt].hide();
        $scope.Modal[opt].remove();
        delete $scope.Modal[opt];
      }

      $scope.addToCart = function() {
        var formData = {'list_type':'shopping_cart', 'listing_id':$scope.variant.sku};
        cartService.add_to_cart(formData).then(function(result) {
          if (result !== 'error') {
            $state.go('cart');
          }
        });
      }

      $scope.expressCheckout = function(){
        infibeamCheckoutService.express_checkout($scope.variant.sku).then(function(response) {
        if (response.meta !== undefined && response.meta.result === "success") {
          $state.go('checkout');          
        } else {
          $cordovaToast.showLongTop("Error while starting checkout. Please try after some time.");
        }
      });
  };

    }
  }
}])

.directive('vtitle',function(){
  return{
    restrict: 'EA',
    replace:true,
    template: '<div class="variant-title">{{variant.title}} <span ng-if="variant.binding">( {{variant.binding}} )</span></div>'
  }
})

.directive('vimage',['babConfig',function(babConfig){
  return{
    restrict: 'EA',
    replace:true,
    template: '<img class="variant-image" src="'+babConfig.host+'{{variant.default_image.url}}"/>'
  }
}])

.directive('vprice',function(){
  return{
    restrict: 'EA',
    replace:true,
    template: '<span class="variant-price"> {{variant.wsp.value | currency:"&#8377; ":0}}</span>'
  }
})

.directive('voff',function(){
  return{
    restrict: 'EA',
    replace:true,
    template: '<span class="variant-price">{{ ("[" + variant.discount_percent + "% OFF]") }}</span>'
  }
})

.directive('vListPrice',function(){
  return{
    restrict: 'EA',
    replace:true,
    template: '<span class="variant-price strike-through"> {{variant.list_price.value | currency:"&#8377; ":0}}</span>'
  }
})

.directive('vquantity',function(){
  return{
    restrict: 'EA',
    replace:true,
    template: '<span class="variant-qty">{{variant.quantity}}</span>'
  }
})

