angular.module('pnpPushNotificationRegister', ['pnpCore'])
.service('appRegistrationService',['localStorageService', 'babRA', '$cordovaDevice', 'loginRA', 
	function(localStorageService, babRA, $cordovaDevice, loginRA) {
		this.registerApp = function(pnType, pnRegId, referer, advertiserId) {
			if (localStorageService.get('appRegId') === null 
		      || localStorageService.get('buildCommit') !== Infibeam.build) {
				var registrationDetails =  {
				"pn_type" : pnType,
				"pn_reg_id" : pnRegId,
				"platform" : $cordovaDevice.getPlatform(),
				"device_version" : $cordovaDevice.getVersion(),
				"device_uuid" : $cordovaDevice.getUUID(),
				"cordova_version" : $cordovaDevice.getCordova(),
				"device_model" : $cordovaDevice.getModel(),
				"screen_height" : screen.width,
				"screen_width" : screen.height,
				"pixel_ratio" : window.devicePixelRatio,
				"build_commit" : Infibeam.build,
				"device_architecture" : Infibeam.architecture,
				"referer" : referer,
				"advertiser_id" : advertiserId
				};
		      	babRA.one('app-registrations', 'random').all('register').post(registrationDetails).then(
					function(result) {
						if (result.meta.result === "success") {
							localStorageService.set('appRegId', result.app_registration_id);
							localStorageService.set('buildCommit', result.build_commit);
							localStorageService.set('pnTypeRegId', (result.pn_type+'_'+result.pn_reg_id));
							babRA.setDefaultHeaders({
					          'Content-Type': 'application/json',
					          'X-Requested-With': 'XMLHttpRequest',
					          'From-App': 'True',
					          'AppRegId': result.app_registration_id,
					          'versionCode' : window.Infibeam.versionCode
					        });
					        loginRA.setDefaultHeaders({
					          'Content-Type': 'application/json',
					          'X-Requested-With': 'XMLHttpRequest',
					          'From-App': 'True',
					          'AppRegId': result.app_registration_id,
					          'versionCode' : window.Infibeam.versionCode
					        });
						}
					}
				);
		    } else if (localStorageService.get('pnTypeRegId') === null 
		      || localStorageService.get('pnTypeRegId') != (pnType+'_'+pnRegId)) {
				var pnDetails = {
					"app_registration_id" : localStorageService.get("appRegId"),
					"pn_type" : pnType,
					"pn_reg_id" : pnRegId
				}
		      
				babRA.one('app-registrations', 'random').all('updatePnDetails').post(pnDetails).then(
					function(result) {
						console.log(JSON.stringify(result));
						if (result.meta.result === "success") {
							localStorageService.set('pnTypeRegId', (result.pn_type+'_'+result.pn_reg_id));
						}
					}
				);			
			}
		}
	}	
]);