angular.module('pnpRecharge')
	.controller('rechargeCntrl', ['$scope', '$state', 'rechargeService','$ionicModal','$ionicTabsDelegate',
	function($scope, $state, rechargeService, $ionicModal,$ionicTabsDelegate) {
		
		
		$scope.init = function(index){
			if (rechargeService.redirect_to_checkout()) {
				$scope.recharge=rechargeService.recharge_obj;
	 			$scope.recharge_checkout($scope.recharge.service);
	 		}
			$scope.recharge = {};
			mob_regex = /^(\+\d{1,3}[- ]?)?\d{10}$/;
			$scope.plans=[];
			$scope.plan_selection=0;
			$scope.recharge.transactionType = "ETOP";
			$scope.recharge.operator="0";
			$scope.recharge.region="all";
			$ionicTabsDelegate.select(index);
			$scope.show_tn_type = false;
		}

		$scope.validate_mobile = function(){
			return mob_regex.test($scope.recharge.serviceNumber);
		}

		$scope.validate_amount = function(){
			return $scope.recharge.amount!=undefined;
		}

		$scope.validate_operator = function(){
			return $scope.recharge.operator!="0";
		}

		$scope.validate_region = function(){
			return $scope.recharge.region!="0";
		}

		$scope.validate_mobile_recharge = function(){

			return $scope.validate_mobile() && $scope.validate_amount() && $scope.validate_operator() && $scope.validate_region();
		}

		$scope.validate_dth_recharge = function(){
			return $scope.validate_dth() && $scope.validate_amount() && $scope.validate_operator();	
		}

		$scope.validate_dth = function(){
			return $scope.recharge.serviceNumber!=undefined;
		}

		$scope.fetch_operator_region_details = function(){
			if($scope.validate_mobile($scope.recharge.serviceNumber)){
				rechargeService.operator_region($scope.recharge.serviceNumber).then(function(object){
					$scope.recharge.operator = object.operator;
					$scope.recharge.region = object.region;
					$scope.recharge_plans('Mobile')
				})
			}
		}

		$ionicModal.fromTemplateUrl('pop-up-plans.html', {
	      	scope: $scope,
	     	animation: 'slide-in-up'
	    }).then(function(modal) {
	        $scope.plansModal = modal;
	    });

	    $scope.openPlansModal = function(){
	    	$scope.plansModal.show();
	    }

		$scope.closePlansModal = function(){
	      	$scope.plansModal.hide();
	    } 

	    $scope.select_plan = function(value){
	    	$scope.recharge.amount=value;
	    	$scope.closePlansModal();
	    }

	    $scope.to_upcase = function(str){
	    	return str.replace(/(\_[a-z])/g, function($1){return $1.toUpperCase().replace('_',' ');}).replace(/(^[a-z])/g, function($1){return $1.toUpperCase()}).replace('_',' ');
	    }

		$scope.recharge_plans = function(service){
			rechargeService.get_recharge_plans($scope.recharge.operator,$scope.recharge.region,service).then(function(object){
				if(object.meta.result!='error'){
					$scope.show_tn_type = true;
				}
				else{
					$scope.show_tn_type = false;
				}
				$scope.plans = object.plans;
				keys = _($scope.plans).keys().value();
			})
		}

		$scope.recharge_checkout = function(service){
			$scope.recharge.service = service;
			rechargeService.recharge_checkout($scope.recharge).then(function(response){
				if (response.meta !== undefined && response.meta.result === "success") {
					$state.go('checkout');
					rechargeService.reset_checkout_flags();
			    } else {
			      	$cordovaToast.showLongTop("Error while starting checkout. Please try after some time.");
			    }
			});
		}

		$scope.get_plans = function(){
			keys = _($scope.plans).keys().value();
			return keys;
		}

		$scope.get_plan_category = function(){
			return _($scope.plans).values().value();
		}
		
		$scope.set_operators = function(){
			rechargeService.fetch_operators().then(function(object){
				$scope.operators = object.rechargeOperators;
			});
		}

		$scope.set_regions = function(){
			rechargeService.fetch_regions().then(function(object){
				$scope.regions = object.rechargeRegions;
			});
		}
		$scope.init(0);
		$scope.set_operators();
		$scope.set_regions();
	}])