angular.module('pnpRecharge')
.service('rechargeService', ['babRA', 'checkoutRA', '$state', 
	function(babRA, checkoutRA, $state) {

		this.proceed_to_checkout = false;
		this.recharge_obj = {};

		this.set_recharge_obj = function(obj)  {
			this.proceed_to_checkout = true;
			this.recharge_obj=obj;
		}

		this.reset_checkout_flags = function() {
			this.proceed_to_checkout = false;
			this.recharge_obj = {};
		}

		this.redirect_to_checkout = function() {
			if (this.proceed_to_checkout && this.recharge_obj) {
				return true;
			} else {
				return false;
			}
		}	

		this.operator_region = function(mob_no) {
			return babRA
			.one('recharge','random')
			.customGET('operatorRegionDetails', {mobile: mob_no})
		};

		this.get_recharge_plans = function(operator,region,service){
			return babRA
			.one('recharge','random')
			.customGET('rechargePlans',{'operator':operator,'region':region,'service':service})
		}

		this.recharge_checkout = function(obj){
			if(!this.proceed_to_checkout && obj){
				this.set_recharge_obj(obj);
			}
			return checkoutRA
			.one('create-purchase','random')
			.customGET('createRechargeCheckout',{'service':obj.service,'region':obj.region,'operator':obj.operator,'amount':obj.amount,'transactionType':obj.transactionType,'serviceNumber':obj.serviceNumber})
		}

		this.fetch_operators = function(){
			return babRA
			.one('recharge','random')
			.customGET('rechargeOperators');	
		}
		
		this.fetch_regions = function(){
			return babRA
			.one('recharge','random')
			.customGET('rechargeRegions');	
		}

	}]);
