angular.module('pnpSearch.controllers', ['pnpCore'])
.controller('browseNodeSearchCntrl', ['babRA','$location','$rootScope','$scope', '$cordovaGoogleAnalytics', 'browseNodeService', '$stateParams','$ionicModal', 
	function(babRA,$location,$rootScope,$scope, $cordovaGoogleAnalytics, browseNodeService, $stateParams, $ionicModal) {
		
		browseNodeService.set_querry($location.$$search);
		browseNodeService.set_bn($stateParams.browse_node_title);
		browseNodeService.init_facets();
		
		/////  view_type has view_icon_classes with same index  /////
		$scope.view_types=["grid","list"];
		$scope.view_icon_classes=['ion-grid','ion-navicon-round'];
		$scope.next_view_type_icon = $scope.view_icon_classes[0];
		$scope.view_type = $scope.view_types[1];
		$scope.variants=[];
		$scope.grid_variants = [];
		$scope.page_num=0;
		$scope.moredata = true;
		
      	$scope.apply = function(){
	      $scope.get_search();
	    }

	    $scope.get_search = function(){
	    	$scope.variants = [];
	    	$scope.grid_variants = [];
	    	$scope.page_num=0;
	    	$scope.moredata = true;
	    	$scope.get_next_page();
	    	$scope.facetModal.hide();
	    }

	    $scope.get_results = function(){
	    	return browseNodeService.sresults;
	    }

	    $scope.clear_all = function(){
	      browseNodeService.init_facets();
	      $scope.get_search();
	    }

	    /////  Result view related functionality  /////

		$scope.change_view = function(){
			var index = _.indexOf($scope.view_types,$scope.view_type);
			var index_class = index+1;
			index = ((index+1) % $scope.view_types.length);
			index_class = ((index_class+1) % $scope.view_icon_classes.length);
			$scope.next_view_type_icon = $scope.view_icon_classes[index_class];
			$scope.view_type = $scope.view_types[index];
		}

		$scope.get_tag_class = function(variant){

			if(variant){
				var class_name='';
				if(variant.item_availability=='OutOfStock'){
					class_name = "outstock";
				}
				else if(variant.item_availability=='ComingSoon' || variant.item_availability=='PreOrder'){
					class_name = "comingsoon";
				}
				else{
					class_name='';
				}
				return class_name;
			}
		}

		$scope.get_tag_value = function(variant){
			if(variant){
				if(variant.item_availability!='ComingSoon' && variant.item_availability!='PreOrder'){
					return variant.item_availability.replace(/([a-z][A-Z])/g, function (g) { return g[0] + ' ' + g[1] });	
				}
				else{
					return "Upcoming";
				}
			}
		}
		
		$scope.get_next_page = function(){
			var count = 2;
			if($scope.page_num%3==0 && $scope.moredata && ($scope.page_num!=0)){
				$scope.moredata=false;
				$scope.page_num+=1;
			}
			else{
				if($scope.page_num%3!=1 || $scope.page_num==1){
					$scope.page_num+=1;
				}
				browseNodeService.search_page($scope.page_num).then(function(object){
					var v = [];
					_(object.variants).forEach(function(n,key){
						$scope.variants.push(n)	;
						var chunkIndex = parseInt(key / count, 10);
				      	var isFirst = (key % count === 0);
				      	if (isFirst){
				      		v[0] = n;
				      	}
				      	else{
				      		v[1] = n;
				      		$scope.grid_variants.push(v);
				      		v=[];
				      	}
				    })
				    if(object.variants.length>0){
						$scope.$broadcast('scroll.infiniteScrollComplete');
				    }
				    else{
				    	$scope.moredata=true;
				    }
				});
				if($scope.page_num%3==1 && $scope.page_num!=1){
					$scope.page_num+=1;	
				}
			}
		}
		$scope.get_next_page();
		$scope.load_more = function(){
			$scope.moredata = true;
		}
		/////  Result view related functionality finishes here  /////

		$scope.stringify_array = function(input){
			var out = input.join(',').length>20 ? input.join(',').substring(0,20)+"..." : input.join(',');
		  	return out;
		}

	    /////  Facet modal methods  /////
		$ionicModal.fromTemplateUrl('pop-up-facet.html', {
	      	scope: $scope,
	     	animation: 'slide-in-up'
	    }).then(function(modal) {
	        $scope.facetModal = modal;
	    });
	    
	    $scope.pre_selected_facet_vals = function(facet){
			var selected_vals = [];
			if(facet){
				selected_vals = _.filter(facet.facet_values,{selected:true});
				selected_vals = _.sortBy(selected_vals,'name');
			}
			return selected_vals;
		}

		$scope.pre_unselected_facet_vals =  function(facet){
			var unselected_vals = [];
			if(facet){
				unselected_vals = _.pull(facet.facet_values,{selected:true});
				unselected_vals = _.sortBy(_.filter(unselected_vals,{enabled:true}),'name');
			}
			return unselected_vals;	
		}

		$scope.get_facet_values = function(facet){
	      if(facet){
	        return _.union($scope.pre_selected_facet_vals(facet),$scope.pre_unselected_facet_vals(facet));
	      }
	    }

	    $scope.openFacetModal = function(){
	    	$scope.set_initial_facets(browseNodeService.search_filters());
	    	var facet_list = browseNodeService.facets();
	    	$scope.set_facet(facet_list);
	    	$scope.facetModal.show();
	    }

	    var initial_facets = {};
	    $scope.set_initial_facets = function(facets){
	    	angular.copy(facets,initial_facets);
	    }

	    $scope.get_initial_facets = function(){
	    	return initial_facets;
	    }

	    $scope.set_facet = function(facet_list){
	    	var r={};
	    	var p=[];
	    	_(facet_list).forEach(function(n,key){
	    		r[n.code]=$scope.get_facet_values(n);
				p[key]={};
				p[key]['code']=n.code;
				p[key]['name']=n.name;
				p[key]['type']=n.type;
				p[key]['enabled']=n.enabled;
				if(n.type == "SingleSelect"){
					$scope[n.code] = _(n.facet_values).filter({'selected' : true}).value()[0].code;
				}
			})
	    	$scope.facet_keys=p;
			$scope.facet_list=r;
	    }

	    $scope.closeFacetModal = function(){
	    	browseNodeService.init_facets();
	    	browseNodeService.facet_object=null;
	    	browseNodeService.preload_selected();
	      	$scope.facetModal.hide();
	    } 

	    /////  Getter functions  /////

	    $scope.bn_change_url = function(browse_node_title,querry,top_category){
	    	return "#/browse_nodes/".concat(browse_node_title,"/search?q=",querry,"&top_categories=",top_category);
	    }

		$scope.get_discount = function(variant){
			if(variant){
				return (((variant.list_price.value-variant.final_price.value)/variant.list_price.value)*100).toFixed(0);
			}
		}
			
		$scope.dest_location = function(url){
			var facet_list;
			browseNodeService.set_bn(url);
			browseNodeService.search_page(-1).then(function(){
				facet_list=browseNodeService.get_facet_list();
				$scope.set_facet(facet_list);
			})
	    }

		$scope.get_facet_summary = function(){
			return $scope.stringify_array(browseNodeService.facet_summary());
		}

		$scope.get_page_title = function(){
			if(browseNodeService.current_browse_node()){
				return browseNodeService.current_browse_node().display_name;
			}
			else{
				return "";
			}
	    }

	    $scope.get_num_results = function(){
	      return browseNodeService.num_results();
	    }

	    $scope.get_querry_string = function(){
	    	return browseNodeService.querry_string();
	    }
	}
]);
