angular.module('pnpWishlist', ['pnpCore'])

.directive('wishlist',function(){
  var wishlist = {};
  wishlist.restrict = "EA";
  wishlist.scope = {
    variant : "=wishlistVariant"
  }
  wishlist.templateUrl = "lib/pnp-wishlist/templates/wishlist.html" ;
  
  wishlist.controller = function($scope, $ionicModal,notificationService,localStorageService,cartService) {
      $scope.InWishlist = function(){
        if(!$scope.variant) return false;
        var wishlistIds = localStorageService.get('WishList') || "";
        return (wishlistIds.indexOf($scope.variant.sku) > -1) ? true : false;
      }

       $scope.addToWishlist = function() {
        var formData = {'list_type':'WishList', 'listing_id':$scope.variant.sku};
        cartService.add_to_cart(formData).then(function(result) {
          if(result!== 'error'){
            var wishlistIds = localStorageService.get('WishList') || "";
            wishlistIds = wishlistIds + "|"+$scope.variant.sku;
            localStorageService.set('WishList',wishlistIds );
            notificationService.add("Added to WishList","success");  
          }
        });
      }

      $scope.removeFromWishlist = function() {
        var formData = {'list_type':'WishList', 'listing_id':$scope.variant.sku};
        cartService.delete_item(formData).then(function(result) {
          if(result!== 'error'){
            var wishlistIds = localStorageService.get('WishList');
            if(wishlistIds.indexOf($scope.variant.sku) > -1){
              wishlistIds = wishlistIds.replace("|"+$scope.variant.sku,"")
            }
            localStorageService.set('WishList',wishlistIds );
            notificationService.add("Removed From WishList","success");  
          }
        });
      }
  }
  return wishlist;
})